# granular

Simulate granular mechanics with realistic physics and minimal
external dependencies.


## Building and installing

To build a fast version for performance, compile with the following
command:

    $ make CFLAGS="-O3"

To build with debug symbols for development, compile with the command:

    $ make CFLAGS="-Wall -Wextra -pedantic -g"


## Usage

This software consists of a series of programs each serving individual
purposes.  The user combines these programs in a way suitable for
their needs.

The purpose, usage, and input/output formats of all programs are
documented in their respective man pages, available after `make
install`:

    man 5 granular       # documentation on the general granular format
    man granular         # simulate interaction over time
    man granular2img     # conversion of the granular format to images
    man granular2vtu     # conversion of the granular format to VTK format
    man granularenergy   # calculate kinetic and potential energy
    man granulargrain    # program for creating a single grain
    man granularpacking  # create an assemblage of grains

There are usage examples (*.sh) which are by default installed to
/usr/local/share/doc/granular/.


## Author

Anders Damsgaard https://adamsgaard.dk
