#ifndef ARRAYS_
#define ARRAYS_

#include <stdio.h>

unsigned int idx3(
        const unsigned int i, const unsigned int j, const unsigned int k,
        const unsigned int nx, const unsigned int ny);

unsigned int idx3g(
        const unsigned int i, const unsigned int j, const unsigned int k,
        const unsigned int nx, const unsigned int ny);

unsigned int idx2(
        const unsigned int i, const unsigned int j, const unsigned int nx);

unsigned int idx2g(
        const unsigned int i, const unsigned int j, const unsigned int nx);

unsigned int idx1g(const unsigned int i);

double * spacing(const double *x, const int n);
double * linspace(const double lower, const double upper, const int n);
double * zeros(const int n);
double * ones(const int n);
double * initval(const double value, const int n);
double * empty(const int n);

double max(const double *a, const int n);
double min(const double *a, const int n);

void print_array(const double *a, const int n);
void print_arrays(const double *a, const double *b, const int n);
void print_arrays_2nd_normalized(const double *a, const double *b, const int n);
void print_three_arrays(
        const double *a,
        const double *b, 
        const double *c, 
        const int n);

void fprint_arrays(FILE *fp, const double *a, const double *b, const int n);

void fprint_three_arrays(
        FILE *fp,
        const double *a,
        const double *b, 
        const double *c, 
        const int n);

void copy_values(const double *in, double *out, const int n);
double * copy(const double *in, const int n);
double * normalize(const double *in, const int n);

double euclidean_norm(const double *a, const int n);
double euclidean_distance(const double *a, const double *b, const int n);
double dot(const double *a, const double *b, const int n);
double * cross(const double a[3], const double b[3]);

#endif
