#ifndef GRANULAR_UTIL_
#define GRANULAR_UTIL_

#define LENGTH(X)	(size_t)(sizeof X / sizeof X[0])

void warn_parameter_value(const char message[], const double value, int *status);
void check_float(const char name[], const double value, int *status);
void check_float_non_negative(const char name[], const double value, int *status);
void check_float_positive(const char name[], const double value, int *status);
void check_int_bool(const char name[], const int value, int *status);
void check_int_non_negative(const char name[], const int value, int *status);

double residual(const double new_val, const double old_val);

double random_value_uniform(double min, double max);
double random_value_powerlaw(double min, double max);

void * xreallocarray(void *m, size_t n, size_t s);

double harmonic_mean(double a, double b);

#endif
